// ----------------------------------------
// Приложение FONTVIEW
// Просмотр шрифтов
// ----------------------------------------

#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <commdlg.h>
#include <mem.h>
#pragma hdrstop

#include "fontview.hpp"

// Прототипы функций
BOOL InitApp(HINSTANCE);
LRESULT CALLBACK _export WndProc(HWND, UINT, WPARAM, LPARAM);
BOOL GetFont(HWND hWnd, LOGFONT *lf, CHOOSEFONT *cf);

// Имя класса окна
char const szClassName[]   = "FontViewClass";

// Заголовок окна
char const szWindowTitle[] = "Font Viewer";

// Размеры внутренней области окна
short cxClient, cyClient;

// Идентификатор копии приложения
HINSTANCE hInst;

// Строка для вывода
char szChars[] = ": AaBbCcDdEeFfGg АаБбВвГгДдЕе";
char szBuf[256];

// Угол наклона строки при выводе
int nOrientation = 0;

// =====================================
// Функция WinMain
// =====================================
#pragma argsused

int PASCAL
WinMain(HINSTANCE hInstance, 
	HINSTANCE hPrevInstance,
	LPSTR     lpszCmdLine, 
	int       nCmdShow)
{
  MSG  msg;   // структура для работы с сообщениями
  HWND hwnd;  // идентификатор главного окна приложения

  // Инициализируем приложение
  if(!InitApp(hInstance))
      return FALSE;

  hInst = hInstance;

  // После успешной инициализации приложения создаем
  // главное окно приложения
  hwnd = CreateWindow(
    szClassName,         // имя класса окна
    szWindowTitle,       // заголовок окна
    WS_OVERLAPPEDWINDOW, // стиль окна
    CW_USEDEFAULT,       // задаем размеры и расположение
    CW_USEDEFAULT,       // окна, принятые по умолчанию
    CW_USEDEFAULT,
    CW_USEDEFAULT,
    0, 0, hInstance, NULL);      
                       
  // Если создать окно не удалось, завершаем приложение
  if(!hwnd)
    return FALSE;

  // Рисуем главное окно
  ShowWindow(hwnd, nCmdShow);
  UpdateWindow(hwnd);

  // Запускаем цикл обработки сообщений
  while(GetMessage(&msg, 0, 0, 0))
  {
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

// =====================================
// Функция InitApp
// Выполняет регистрацию класса окна
// =====================================

BOOL
InitApp(HINSTANCE hInstance)
{
  ATOM aWndClass; // атом для кода возврата
  WNDCLASS wc;    // структура для регистрации
                  // класса окна

  // Записываем во все поля структуры нулевые значения
  memset(&wc, 0, sizeof(wc));

  // Подключаем меню 
  wc.lpszMenuName  = "APP_MENU";

  wc.style         = CS_HREDRAW | CS_VREDRAW;
  wc.lpfnWndProc   = (WNDPROC) WndProc;
  wc.cbClsExtra    = 0;
  wc.cbWndExtra    = 0;
  wc.hInstance     = hInstance;
  wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
  wc.lpszClassName = (LPSTR)szClassName;

  // Регистрация класса
  aWndClass = RegisterClass(&wc);

  return (aWndClass != 0);
}

// =====================================
// Функция WndProc
// =====================================

LRESULT CALLBACK _export
WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  HDC hdc;
  PAINTSTRUCT ps;
  static CHOOSEFONT cf;
  static LOGFONT lf;
  static HFONT hfont, hfOldFont;;

  switch (msg)
  {
    // При изменении размеров окна сохраняем
    // новые значения для ширины и высоты
    case WM_SIZE:
    {
      cxClient = LOWORD(lParam);
      cyClient = HIWORD(lParam);
      return 0;
    }

    // Рисование в окне
    case WM_PAINT:
    {
      // Получаем контекст отображения для
      // рисования во внутренней области окна 
      hdc = BeginPaint(hwnd, &ps);

      // Устанавливаем угол наклона строки
      lf.lfOrientation = lf.lfEscapement = nOrientation;

      // Создаем шрифт на базе заполненной
      // структуры LOGFONT
      hfont = CreateFontIndirect(&lf);

      if(hfont)
      {
        // Выбираем шрифт в контекст отображения
        hfOldFont = SelectFont(hdc, hfont);

        // Определяем название шрифта
        GetTextFace(hdc, 80, szBuf);

        // Добавляем к нему текстовую строку
        lstrcat(szBuf, szChars);

        // Устанавливаем цвет текста
        SetTextColor(hdc, cf.rgbColors);

        // Выводим текст, пользуясь выбранным шрифтом
        TextOut(hdc, cxClient/2, cyClient/2,
          szBuf, lstrlen(szBuf));

        // Выбираем старый шрифт
        SelectFont(hdc, hfOldFont);

        // Удаляем созданный нами шрифт 
        DeleteFont(hfont);
      }

      // Освобождаем контекст отображения
      EndPaint(hwnd, &ps);
      return 0;
    }

    // Обработка сообщений от меню
    case WM_COMMAND:
    {
      switch (wParam)
      {
        // Выбор шрифта при помощи диалоговой панели
        case CM_FONTSEL:
        {
          // Записываем во все поля структуры типа
          // LOGFONT нулевые значения
          memset(&lf, 0, sizeof(LOGFONT));

          // Выбираем шрифт
          if(GetFont(hwnd, &lf, &cf))
          {
            // Перерисовываем окно
            InvalidateRect(hwnd, NULL, TRUE);
          }
          return 0;
        }

        // Выбираем шрифт, указывая семейство
        case CM_FDECOR:
        {
          memset(&lf, 0, sizeof(LOGFONT));
          lf.lfPitchAndFamily = FF_DECORATIVE;
          InvalidateRect(hwnd, NULL, TRUE);
          return 0;
        }
        case CM_FMODERN:
        {
          memset(&lf, 0, sizeof(LOGFONT));
          lf.lfPitchAndFamily = FF_MODERN;
          InvalidateRect(hwnd, NULL, TRUE);
          return 0;
        }
        case CM_FROMAN:
        {
          memset(&lf, 0, sizeof(LOGFONT));
          lf.lfPitchAndFamily = FF_ROMAN;
          InvalidateRect(hwnd, NULL, TRUE);
          return 0;
        }
        case CM_FSCRIPT:
        {
          memset(&lf, 0, sizeof(LOGFONT));
          lf.lfPitchAndFamily = FF_SCRIPT;
          InvalidateRect(hwnd, NULL, TRUE);
          return 0;
        }
        case CM_FSWISS:
        {
          memset(&lf, 0, sizeof(LOGFONT));
          lf.lfPitchAndFamily = FF_SWISS;
          InvalidateRect(hwnd, NULL, TRUE);
          return 0;
        }

        // Выбираем угол поворота строки
        case CM_FONT00:
        {
          nOrientation = 0;
          InvalidateRect(hwnd, NULL, TRUE);
          return 0;
        }
        case CM_FONT30:
        {
          nOrientation = 300;
          InvalidateRect(hwnd, NULL, TRUE);
          return 0;
        }
        case CM_FONT45:
        {
          nOrientation = 450;
          InvalidateRect(hwnd, NULL, TRUE);
          return 0;
        }
        case CM_FONT90:
        {
          nOrientation = 900;
          InvalidateRect(hwnd, NULL, TRUE);
          return 0;
        }
        case CM_FONT180:
        {
          nOrientation = 1800;
          InvalidateRect(hwnd, NULL, TRUE);
          return 0;
        }
        case CM_FONT270:
        {
          nOrientation = 2700;
          InvalidateRect(hwnd, NULL, TRUE);
          return 0;
        }
        case CM_FONT360:
        {
          nOrientation = 3600;
          InvalidateRect(hwnd, NULL, TRUE);
          return 0;
        }

        case CM_HELPABOUT:
        {
          MessageBox(hwnd,
            "Font Viewer, v.1.0\n"
            "(C) Frolov A.V., 1994",
	    "About FONTVIEW", MB_OK | MB_ICONINFORMATION);
          return 0;
        }

        // Завершаем работу приложения
        case CM_FILEEXIT:
        {
          DestroyWindow(hwnd);
          return 0;
        }

        default:
          return 0;
      }
    }

    case WM_DESTROY:
    {
      PostQuitMessage(0);
      return 0;
    }

    default:
      break;
  }
  return DefWindowProc(hwnd, msg, wParam, lParam);
}

// =====================================
// Функция GetFont
// =====================================

BOOL GetFont(HWND hWnd, LOGFONT *lf, CHOOSEFONT *cf)
{
  LPSTR szFontStyle[LF_FACESIZE];

  // Записываем нулевые значения во все поля
  // структуры, которая будет использована для
  // выбора шрифта
  memset(cf, 0, sizeof(CHOOSEFONT));

  // Размер структуры
  cf->lStructSize = sizeof(CHOOSEFONT);

  // Идентификатор окна
  cf->hwndOwner = hWnd;

  // Указатель на структуру LOGFONT 
  cf->lpLogFont = lf;

  // Флаги, определяющие внешний вид диалоговой панели
  cf->Flags = CF_SCREENFONTS | CF_USESTYLE
            | CF_EFFECTS;

  // Дополнительные данные
  cf->lCustData = 0L;

  // Цвет текста
  cf->rgbColors = RGB(0,0,0);

  // Адрес функции фильтра 
  cf->lpfnHook = (FARPROC)NULL;

  // Адрес шаблона диалоговой панели 
  cf->lpTemplateName = (LPSTR)NULL;

  // Идентификатор копии прилоджения
  cf->hInstance = hInst;

  // Стиль шрифта
  cf->lpszStyle = (LPSTR)szFontStyle;

  // Тип шрифта
  cf->nFontType = SCREEN_FONTTYPE;

  // Ограничения на минимальный и максимальный
  // размер шрифта
  cf->nSizeMin = 0;
  cf->nSizeMax = 0;

  // Вызываем функцию выбора шрифта
  return ChooseFont(cf);
} 




